/*
  h_file.h   Nov98  JS  ---  please look at h_file.c for more infos
  
*/
#ifndef _H_FILE_H
#define _H_FILE_H

#include "config.h"
#include "defs.h"

/* ----------    packed-struct-array (obsolete) -----------------------
  struct thxy {			      // y,h[x,y] if(x=y)x++;
    int  xy __attribute__ ((packed)) ; // 4 Byte 
    char r  __attribute__ ((packed)) ; // 1 Byte 
  }; // 5 Byte packet, 8 Byte aligned!
 * __sparc-gcc2.7.2.3:    cplx=20Byte buserror in nhm hxy.r=r;
 * __sgi-CC: no __attribute__ 
 * __hp9000s800-gcc2.7.0: cplx=20Byte buserror in nhm hxy.r=r;
 * __alpha_ev5__-gcc2.95.2: cplx=20Byte unaligned trap at ... (/proc/kmsg)
 * 2D-array (struct of char[3],...) and own assignment-operator to slow
 * struct thxy { char xy[S_int], r[S_char] } + casting-operatoren = same problem
 */

#if 0			/* for test, future version */
#define STORE_XandY 1   /* store XR (filesize/2) or XYR (simpler) in h-file */
#endif
/*
  if HRMAX greater than 0,
  the program stores a index to the double or complex value of the matrix
  element, else the matrix element itself is stored to the disk
 --- if an error apears, choose xy as a next larger type ---
 --- please edit HRMAX too !!! ---
 unsigned char , unsigned int , ULong , ULLong
 */
#ifndef HRMAX		/* can be defined in config.h */
#define HRMAX   255  	/* 255, 1024 or higher, if ERR(9100) */
#endif
#if HRMAX<256
#define HR_TYPE	unsigned char	/* char bis 256 */
#elif HRMAX<65536
#define HR_TYPE	unsigned short	/* short bis 65536 */
#else
#define HR_TYPE	unsigned int	/* int bis 256^4 */
#endif

#define XY_TYPE unsigned int	/* int or long  14Jan00 wegen 64bittern */
#define XY_FLAG (((XY_TYPE)1)<<(sizeof(XY_TYPE)*8-1))	/* bit for last element in a line of H */ 

#if (!defined(HRMAX)) || (HRMAX<=0)
#define HR_TYPE mcplx
#endif

#define HBLen (8*4096) /* elements hxy-read-buffer (HBLen*(XYsize+HRsize)) */
 
/* structure to hold temporary H-matrix elements
 * direct access to nonaligned members cause trap on IRIX, ToDo: xy[],r[]
 */
struct thxy {		/* y,h[x,y] if(x=y)x++;   */
   /* ToDo: add block,bl2 ? -> can be taken from first xx and xy */
   int block; /* vector block == compute thread */
   int len;   /* block dont have to be full,
      dont break H lines to different Hbuffers
      which allows disordered read/write of buffers */
#ifdef STORE_XandY
   XY_TYPE xx[HBLen];   /* line   x of element h[] (32bit) */
#else
   XY_TYPE xx;          /* first line x of h[] block (v2.26) */
#endif
   XY_TYPE xy[HBLen];  	/* column y of element h[] (32bit) */
   HR_TYPE r[HBLen];    /* [index to] NZ-Element (uchar,short,int,mcplx) */
};

#define Hsize sizeof(struct thxy)

extern int h_error;   /* set on write-error */
extern int h_state[B_NUM];    /* 0=closed, 1=ropen, 2=wopen */  

#ifndef B_NUM
#error "we need B_NUM as number of buffers and compute threads defined here"
#endif
#ifndef F_NUM
#error "please define F_NUM = {1..B_NUM} the number of H-files (I/O threads)"
#endif
#if (F_NUM > B_NUM) || (F_NUM < 1) 
#error "F_NUM should be in the range 1 .. B_NUM"
#endif

#if HRMAX>0
 /* table for 16bit index to Hamilton-entries, one per compute thread */
 extern unsigned int hr_len[B_NUM];
 extern cplx hr[B_NUM][HRMAX];	/* better use realloc ? */
#endif

int h_ropen(int block);
int h_wopen(int block);
int h_rclose(int block);
int h_wclose(int block);
int h_read(int block);

/* store/read H-element, block, column=xy+Flag_next_line, value */
/* void h_put(int block, ULong  xx, ULong  xy, cplx  r); */
/* if (!STORE_XandY) only first xx of each block is stored */
/* void h_get(int block, ULong *xx, ULong *xy, cplx *r); */
size_t my_fread( char *ptr, size_t size, size_t nmemb, int block);
size_t my_fwrite( void *ptr, size_t size, size_t nmemb, int block);
extern int h_state[B_NUM];    /* 0=closed, 1=ropen, 2=wopen */
void err_fulltable();

void ini_thxy(ULong n1);
/* if vvv outut info */
void close_thxy(int vvv);
void restore_thxy(int vvv);
#endif
